import sys
sys.path.insert(0, './lib')
sys.path.insert(0, '..') #append parent directory

import hp4155a
from interface import *
from help import *

sample = sample_information_interface()
parameters_1 = parameters_interface(0,0.02,10,"First Measurement")
parameters_2 = parameters_interface(0,-0.5,-100,"Second Measurement")
button = widgets.Button(description ='Start Measurement')
output = widgets.Output()

display(button,output)
all_widgets = [button]
add_widgets_to_list(sample,all_widgets)
add_widgets_to_list(parameters_1,all_widgets)
add_widgets_to_list(parameters_2,all_widgets)


device = hp4155a.HP4155a('GPIB0::17::INSTR')
setup(device)
def on_button_clicked(b):
    with output:
        clear_output(wait = True)
        change_state(all_widgets)
        area=circle_area(sample['radius'].value)
        
        valid = check_values(parameters_1) and check_values(parameters_2)
        if valid == True:
            df = measure(parameters_1,parameters_2,area,device)
            plot_results(df['VS'],df['ABSNOR'])
            filename = f"pn_diode_{sample['field'].value}.txt"
            file = create_file(filename)
            save_to_file(df,sample,parameters_1,parameters_2,file)
        
        change_state(all_widgets)



button.on_click(on_button_clicked)